#! /usr/bin/env python

import glob, os, string, sys

def make_automatic():

    # Look for a module called sitecustomize in the paths contained in sys.path.
    file = None
    
    for path in sys.path:
    
        # Construct a wildcarded path to use to find this module.
        wild_path = os.path.join(path, "sitecustomize*")
        
        # Find all files matching the pattern given.
        files = glob.glob(wild_path)
        
        if files != []:
        
            # If files are found then take the first listed.
            file = files[0]
            break
    
    if file is not None:
    
        try:
        
            # Read the contents of the file.
            lines = string.split(open(file, "r").read(), "\n")
            
            # Check for an existing import directive for this module.
            if "import xhtmlhook" not in lines:
            
                # Add a line to the end of the file found.
                lines = lines + [
                    "# Added by setup.py file for the xhtmlhook module.",
                    "import xhtmlhook", ""
                    ]
                
                open(file, "w").write(string.join(lines, "\n"))
                print '"import xhtmlhook" added to %s' % file
            
            else:
            
                print '"import xhtmlhook" already found in %s' % file
        
        except IOError:
        
            print "Could not add the xhtmlhook module to the list of site" + \
                "modules to be imported by default."
        
    else:
    
        # Create a new sitecustomize module.
        
        print "Please choose a directory in which to install a sitecusomize"
        print "module (see the documentation for site.py for details of this"
        print "file)."
        print
        
        i = 1
        for path in sys.path:
        
            print i, path
            i = i + 1
        
        print
        
        while 1:
        
            q = raw_input("[1] > ")
            
            if q == "": q = 1
            
            try:
            
                index = int(q) - 1
                
                if index < 0 or index >= len(sys.path):
                
                    raise ValueError, "Out of range"
                
                break
            
            except ValueError:
            
                print "Please specify an integer within the range given."
                print
        
        try:
        
            file = os.path.join(
                sys.path[index], "sitecustomize" + os.extsep + "py"
                )
            
            lines = [
                "# Added by setup.py file for the xhtmlhook module.",
                "import xhtmlhook", ""
                ]
            
            open(file, "w").write(string.join(lines, "\n"))
            print '"import xhtmlhook" added to %s' % file
        
        except IOError:
        
            print "Could not add the xhtmlhook module to the list of site" + \
                "modules to be imported by default."

# Use non-destructive method of looking at the command line arguments.
if len(sys.argv) > 1 and sys.argv[1] == "build":

    # Read the path to this file.
    path = sys.argv[0]
    
    # Extract the path of the directory containing this file.
    path, file = os.path.split(path)
    
    # Run the xhtml2py script.
    import xhtml2py
    
    # Generate the necessary files from the distribution.
    xhtml2py.main(path, "xhtmlhook")
    print "Created xhtmlhook.py"

from distutils.core import setup

setup(
    name="xhtmlhook",
    description="Import hooks for preformatted Python in XHTML documents " + \
                "and importing modules from URLs.",
    long_description="Extracts and imports Python code from preformatted " + \
                     "elements in XHTML documents from remote hosts or " + \
                     "local files. URLs can be added to the list of " + \
                     "standard paths or modules can be imported directly " + \
                     "using a convenience function." + \
                     "The import hook can also be used to import other " + \
                     "standard file types from remote locations.",
    author = "David Boddie",
    author_email = "david@boddie.org.uk",
    maintainer = "David Boddie",
    maintainer_email = "david@boddie.org.uk",
    url = "http://www.boddie.org.uk/python/xhtmlhook/",
    version = "1.12",
    py_modules=["xhtmlhook"],
    classifiers=["Topic :: Text Processing :: Markup :: XML",
                 "License :: OSI Approved :: GNU General Public License (GPL)"]
    )

# Use non-destructive method of looking at the command line arguments.
if len(sys.argv) > 1 and sys.argv[1] == "install":

    print
    q = raw_input(
        "Install module so that Python imports it automatically on startup?"+ \
        " yes/[no] > "
        )
    
    if q == "": q = "no"
    
    if q == "yes":
    
        # Make the module one which is automatically imported by Python
        # at startup.
        make_automatic()
